NXOpen .NET Reference  12.0.0
Public Types | Public Member Functions | Properties | List of all members
NXOpen.Section Class Reference

Represents a section More...

Inheritance diagram for NXOpen.Section:
NXOpen.DisplayableObject NXOpen.NXObject NXOpen.IFitTo NXOpen.INXObject NXOpen.INXObject

Public Types

enum  Mode { Create, Edit }
 Defines mode with respect to feature create or edit mode. More...
 
enum  AllowTypes { Uninitialized, OnlyCurves, OnlyPoints, CurvesAndPoints }
 Defines entity types allowed. More...
 
enum  DeselectOption { SectionBetweenIntersection, CurveBetweenIntersection }
 Defines type of deselect option. More...
 
- Public Types inherited from NXOpen.DisplayableObject
enum  ObjectWidth {
  Normal, Thick, Thin, One = 5,
  Two, Three, Four, Five,
  Six, Seven, Eight, Nine
}
 specifies object width for objects such as lines and text More...
 
enum  ObjectFont {
  Solid = 1, Dashed, Phantom, Centerline,
  Dotted, LongDashed, DottedDashed
}
 specifies the object font for objects such as lines More...
 
- Public Types inherited from NXOpen.NXObject
enum  AttributeType {
  Invalid, Null, Boolean, Integer,
  Real, String, Time, Reference,
  Any = 100
}
 Specifies attribute type. More...
 
enum  DateAndTimeFormat { Numeric, Textual }
 Specifies the format of the date and time attribute. More...
 

Public Member Functions

unsafe void AddToSection (NXOpen.SelectionIntentRule[] rules, NXOpen.NXObject seed, NXOpen.NXObject startConnector, NXOpen.NXObject endConnector, NXOpen.Point3d helpPoint, NXOpen.Section.Mode featureMode)
 Adds selection intent rules to the section. More...
 
unsafe void AddToSection (NXOpen.SelectionIntentRule[] rules, NXOpen.NXObject seed, NXOpen.NXObject startConnector, NXOpen.NXObject endConnector, NXOpen.Point3d helpPoint, NXOpen.Section.Mode featureMode, bool chainWithinFeature)
 Adds selection intent rules to the section with the option of restricting chaining and limit discovery to a single feature. More...
 
unsafe void RemoveRules (NXOpen.SelectionIntentRule[] rules, NXOpen.NXObject startConnector, NXOpen.NXObject endConnector, NXOpen.Section.Mode featureMode)
 Removes selection intent rules from the section. More...
 
unsafe void RemoveSingleSectionElement (NXOpen.ICurve sectionElement, NXOpen.NXObject startConnector, NXOpen.NXObject endConnector, NXOpen.Section.Mode featureMode)
 Removes one section element curve. More...
 
unsafe void RemoveSingleSectionElement (NXOpen.Point sectionElement, NXOpen.Section.Mode featureMode)
 Removes one section element that is a point. More...
 
unsafe void RemoveRules (NXOpen.ICurve sectionElement, NXOpen.NXObject startConnector, NXOpen.NXObject endConnector, NXOpen.Section.Mode featureMode)
 Removes all the selection intent rules related to the section element. More...
 
unsafe void RemoveUnderlyingChain (NXOpen.Point3d pointSpecifyingChain, double tolerance, NXOpen.Section.Mode featureMode)
 Removes all the selection intent rules related to the chain on which the given point lies. More...
 
unsafe void SetStartAndDirection (NXOpen.ICurve startElement, NXOpen.Point3d startPoint, NXOpen.Vector3d direction)
 Sets the start element and the direction of the section. More...
 
unsafe void GetStartAndDirection (out NXOpen.ICurve startElement, out NXOpen.Point3d startPoint, out NXOpen.Vector3d direction)
 Gets the start element and the direction of the section. More...
 
unsafe void GetStartAndDirectionOfLoop (int index, out NXOpen.Point3d startPoint, out NXOpen.Vector3d direction)
 Gets the start point and the direction of a specified single loop of the section. More...
 
unsafe void GetSectionData (out NXOpen.SectionData[] sectionData)
 Gets the section data More...
 
unsafe void Destroy ()
 Destroy the section object More...
 
unsafe void ReverseDirection ()
 Reverse the section direction More...
 
unsafe void ReverseDirectionOfLoop (int index)
 Reverse the direction of of a specified single loop of the section. More...
 
unsafe void SetStartCurveOfClosedLoop (int index, NXOpen.Point3d pointOnStartCurve)
 Set the curve on which the specified point lies as the start curve of a specified single loop of the section. More...
 
unsafe void ReverseDirectionOfClosedLoop (int index)
 Reverse the loop direction of a closed loop while keeping the start curve same. More...
 
unsafe void AddSmartPoint (NXOpen.Point smartPt, double tol)
 Add smart point into section. More...
 
unsafe void AllowSelfIntersection (bool allowSelfIntersection)
 Allow self intersecting section or not. More...
 
unsafe void Clear ()
 Clear the section of all its constituents More...
 
unsafe int GetLoopIndex (NXOpen.NXObject sectionElement)
 Returns the index of the section loop conatining the section element. More...
 
unsafe int GetLoopIndex (NXOpen.Point3d pointSpecifyingLoop, double tolerance)
 Returns the index of the loop on which the given point lies. More...
 
unsafe void AlignDirectionOfLoop (NXOpen.Point3d point, NXOpen.Vector3d direction)
 Set the direction of a single loop of the section along the given vector. More...
 
unsafe void SetInterpart (bool interpart)
 Set inter-part state of section and make it empty. More...
 
unsafe void RemoveMultipleCurves (NXOpen.ICurve[] wfs, NXOpen.NXObject[] startConnector, NXOpen.NXObject[] endConnector, NXOpen.Section.Mode featureMode)
 Removes multiple section elements that are either curves/edges. More...
 
unsafe void RemoveMultiplePoints (NXOpen.Point[] points, NXOpen.Section.Mode featureMode)
 Removes multiple section elements that are points. More...
 
unsafe void RemoveUnderlyingCurve (NXOpen.Point3d pointSpecifyingCurve, double tolerance, NXOpen.Section.Mode featureMode)
 Removes the single curve which is within tolerance to the given point, from the section. More...
 
unsafe void RemoveMultipleElements (NXOpen.ICurve[] wfs, NXOpen.NXObject[] startConnectors, NXOpen.NXObject[] endConnectors, bool[] isCombinationsResultIntoOnlyOneCurvePerCombination, NXOpen.Point3d[] pointsOnCurvesToBeRemoved, NXOpen.Point[] points, NXOpen.Section.Mode featureMode)
 Removes multiple section elements. More...
 
unsafe NXOpen.Section CloneSection ()
 Clone section. More...
 
unsafe void PrepareMappingData ()
 Prepares Mapping Data More...
 
unsafe void CleanMappingData ()
 Cleans Mapping Data More...
 
unsafe NXOpen.Section.AllowTypes GetAllowedEntityTypes ()
 Get the Allowed Entity Types. More...
 
unsafe void SetAllowedEntityTypes (NXOpen.Section.AllowTypes allowedEntityTypes)
 Set the Allowed Entity Types. More...
 
unsafe void MapSectionElements (NXOpen.NXObject oldWf, NXOpen.NXObject newWf)
 Maps old section curves to new section curves More...
 
unsafe void GetOutputCurves (out NXOpen.NXObject[] outputs)
 Gives the output curves of the section. More...
 
unsafe void GetOldOutputCurves (out NXOpen.NXObject[] oldOutputs)
 Gives the old output curves of the section. More...
 
unsafe void DeselectPortion (NXOpen.Point3d seedPoint, NXOpen.NXObject startLimit, NXOpen.NXObject endLimit, NXOpen.Section.DeselectOption deselectionType)
 Deselects Portion of the section depending on the option provided. More...
 
unsafe void AddChainBetweenIntersectionPoints (NXOpen.SelectionIntentRule[] rules, NXOpen.NXObject startConnector, NXOpen.Point3d startIntersectionPoint, NXOpen.NXObject endConnector, NXOpen.Point3d endIntersectionPoint, NXOpen.NXObject seed, NXOpen.Point3d helpPoint, NXOpen.Section.Mode featureMode, bool chainWithinFeature)
 Adds a chain between given two intersection points to the section. More...
 
unsafe void SkipSorting (bool skipSorting)
 Sets the option to skip sorting the section loops or not. More...
 
unsafe void EvaluateAndAskOutputEntities (out NXOpen.NXObject[] refs)
 Recalculates section collection. More...
 
unsafe bool GetMultiComponent ()
 Gets the option set on Section for collection from multiple components. More...
 
unsafe void SetMultiComponent ()
 Sets the true option on Section for collection from multiple components. More...
 
unsafe bool GetNonFeatureMode ()
 Gets the option set on Section for collection in non-feature mode. More...
 
unsafe void SetNonFeatureMode ()
 Sets the true option on Section for collection in non-feature mode. More...
 
unsafe void SetAllowRefCrvs (bool allowRefCrvs)
 Sets to the section whether to allow reference curves or not. More...
 
unsafe void GetSectionData (bool withOccurrenceInfo, out NXOpen.SectionData[] sectionData)
 Gets the section data More...
 
- Public Member Functions inherited from NXOpen.DisplayableObject
unsafe void Blank ()
 Blanks the object. More...
 
unsafe void Unblank ()
 Unblanks the object. More...
 
unsafe void Highlight ()
 Highlights the object. More...
 
unsafe void Unhighlight ()
 Unhighlights the object. More...
 
unsafe void SetNameLocation (NXOpen.Point3d location)
 Sets the location of the object's name. More...
 
unsafe void RedisplayObject ()
 Redisplays the object in all views. More...
 
unsafe void RemoveViewDependency ()
 Remove dependency on all views from an object. More...
 
- Public Member Functions inherited from NXOpen.NXObject
unsafe void SetUserAttribute (NXOpen.NXObject.AttributeInformation info, NXOpen.Update.Option option)
 Creates or modifies an attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, int value, NXOpen.Update.Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, double value, NXOpen.Update.Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, NXOpen.Update.Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
unsafe void SetTimeUserAttribute (string title, int index, string value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe void SetTimeUserAttribute (string title, int index, NXOpen.NXObject.ComputationalTime value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe void SetBooleanUserAttribute (string title, int index, bool value, NXOpen.Update.Option option)
 Creates or modifies a boolean attribute with the option to update or not. More...
 
unsafe NXOpen.AttributeIterator CreateAttributeIterator ()
 Create an attribute iterator More...
 
unsafe bool HasUserAttribute (NXOpen.AttributeIterator iterator)
 Determines if an attribute exists on the object, that satisfies the given iterator More...
 
unsafe bool HasUserAttribute (string title, NXOpen.NXObject.AttributeType type, int index)
 Determines if an attribute with the given Title, Type and array Index is present on the object Unset attributes will not be detected by this function, as its purpose is to test for the actual presence of the attribute on the object. More...
 
unsafe int GetUserAttributeCount (NXOpen.AttributeIterator iterator)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
unsafe int GetUserAttributeCount (NXOpen.AttributeIterator iterator, bool countArrayAsOneAttribute)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
unsafe int GetUserAttributeCount (NXOpen.NXObject.AttributeType type)
 Gets the count of set attributes on the object, if any, of the given type. More...
 
unsafe int GetUserAttributeCount (NXOpen.NXObject.AttributeType type, bool includeUnset, bool countArrayAsOneAttribute)
 Gets the count of attributes on the object, if any, of the given type. More...
 
unsafe int GetUserAttributeSize (string title, NXOpen.NXObject.AttributeType type)
 Gets the size of the first attribute encountered on the object, if any, with a given Title and Type. More...
 
unsafe bool GetNextUserAttribute (NXOpen.AttributeIterator iterator, out NXOpen.NXObject.AttributeInformation info)
 Gets the next attribute encountered on the object, if any, that satisfies the given iterator. More...
 
unsafe
NXOpen.NXObject.AttributeInformation 
GetUserAttribute (string title, NXOpen.NXObject.AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index. More...
 
unsafe bool GetBooleanUserAttribute (string title, int index)
 Gets a boolean attribute by Title and array Index. More...
 
unsafe int GetIntegerUserAttribute (string title, int index)
 Gets an integer attribute by Title and array Index. More...
 
unsafe double GetRealUserAttribute (string title, int index)
 Gets a real attribute by Title and array Index. More...
 
unsafe string GetStringUserAttribute (string title, int index)
 Gets a string attribute by Title and array Index. More...
 
unsafe string GetTimeUserAttribute (string title, int index)
 Gets a time attribute by Title and array Index. More...
 
unsafe
NXOpen.NXObject.ComputationalTime 
GetComputationalTimeUserAttribute (string title, int index)
 Gets a time attribute by Title and array Index. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (NXOpen.AttributeIterator iterator)
 Gets all the attributes that have been set on the given object, if any, that satisfy the given iterator. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes ()
 Gets all the attributes that have been set on the given object. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (bool includeUnset)
 Gets all the attributes of the given object. More...
 
unsafe string GetUserAttributeAsString (string title, NXOpen.NXObject.AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given title, type and array index. More...
 
unsafe void DeleteUserAttributes (NXOpen.AttributeIterator iterator, NXOpen.Update.Option option)
 Deletes the attributes on the object, if any, that satisfy the given iterator More...
 
unsafe void DeleteUserAttribute (NXOpen.NXObject.AttributeType type, string title, bool deleteEntireArray, NXOpen.Update.Option option)
 Deletes the first attribute encountered with the given Type, Title. More...
 
unsafe void DeleteUserAttributes (NXOpen.NXObject.AttributeType type, NXOpen.Update.Option option)
 Deletes the attributes encountered with the given Type with option to update or not. More...
 
unsafe void SetUserAttributeLock (string title, NXOpen.NXObject.AttributeType type, bool @lock)
 Lock or unlock the given attribute. More...
 
unsafe bool GetUserAttributeLock (string title, NXOpen.NXObject.AttributeType type)
 Determine the lock of the given attribute. More...
 
unsafe NXOpen.NXObject[] GetUserAttributeSourceObjects ()
 Returns an array of objects from which this object presents attributes. More...
 
unsafe void SetPdmReferenceAttribute (string attributeTitle, string attributeValue)
 Sets the value of PDM Reference attribute on the object. More...
 
unsafe string GetPdmReferenceAttributeValue (string attributeTitle)
 Gets the value of PDM Reference attribute for given object. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttribute (string title, bool includeUnset, bool addStringValues, NXOpen.NXObject.AttributeType type)
 Gets the first attribute (or attribute array) encountered on the object, if any, with a given Title and Type. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (bool includeUnset, bool addStringValues)
 Gets all the attributes of the given object. More...
 
unsafe void DeleteAllAttributesByType (NXOpen.NXObject.AttributeType type)
 Deletes all attributes of a specific type. More...
 
unsafe void DeleteAllAttributesByType (NXOpen.NXObject.AttributeType type, NXOpen.Update.Option option)
 Deletes all attributes of a specific type with the option to update or not. More...
 
unsafe void SetAttribute (string title, int value)
 Creates or modifies an integer attribute. More...
 
unsafe void SetAttribute (string title, int value, NXOpen.Update.Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title, double value)
 Creates or modifies a real attribute. More...
 
unsafe void SetAttribute (string title, double value, NXOpen.Update.Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title, string value)
 Creates or modifies a string attribute. More...
 
unsafe void SetAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title)
 Creates or modifies a null attribute which is an attribute with a title and no value. More...
 
unsafe void SetAttribute (string title, NXOpen.Update.Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
unsafe void SetTimeAttribute (string title, string value)
 Creates or modifies a time attribute. More...
 
unsafe void SetTimeAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe int GetIntegerAttribute (string title)
 Gets an integer attribute by title. More...
 
unsafe double GetRealAttribute (string title)
 Gets a real attribute by title. More...
 
unsafe string GetStringAttribute (string title)
 Gets a string attribute value by title. More...
 
unsafe string GetTimeAttribute (NXOpen.NXObject.DateAndTimeFormat format, string title)
 Gets a time attribute by title. More...
 
unsafe string GetReferenceAttribute (string title)
 Gets the reference string (not the calculated value) of a string attribute that uses a reference string. More...
 
unsafe void DeleteAttributeByTypeAndTitle (NXOpen.NXObject.AttributeType type, string title)
 Deletes an attribute by type and title. More...
 
unsafe void DeleteAttributeByTypeAndTitle (NXOpen.NXObject.AttributeType type, string title, NXOpen.Update.Option option)
 Deletes an attribute by type and title with the option to update or not. More...
 
unsafe void SetReferenceAttribute (string title, string value)
 Creates or modifies a string attribute which uses a reference string. More...
 
unsafe void SetReferenceAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute which uses a reference string, with the option to update or not. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetAttributeTitlesByType (NXOpen.NXObject.AttributeType type)
 Gets all the attribute titles of a specific type. More...
 
unsafe string[] GetUserAttributesAsStrings ()
 Gets all the attributes that have been set on the given object. More...
 
unsafe NXOpen.INXObject FindObject (string journalIdentifier)
 Finds the NXOpen.NXObject with the given identifier as recorded in a journal. More...
 
unsafe void Print ()
 Prints a representation of this object to the system log file. More...
 
unsafe void SetName (string name)
 Sets the custom name of the object. More...
 

Properties

unsafe double AngleTolerance [get, set]
 Returns or sets the angle tolerance More...
 
unsafe double ChainingTolerance [get, set]
 Returns or sets the chaining tolerance More...
 
unsafe double DistanceTolerance [get, set]
 Returns or sets the distance tolerance More...
 
- Properties inherited from NXOpen.DisplayableObject
unsafe int Color [get, set]
 Returns or sets the color of the object. More...
 
unsafe bool IsBlanked [get]
 Returns the blank status of this object. More...
 
unsafe int Layer [get, set]
 Returns or sets the layer that the object is in. More...
 
unsafe
NXOpen.DisplayableObject.ObjectFont 
LineFont [get, set]
 Returns or sets the line font of the object. More...
 
unsafe
NXOpen.DisplayableObject.ObjectWidth 
LineWidth [get, set]
 Returns or sets the line width of the object. More...
 
unsafe NXOpen.Point3d NameLocation [get]
 Returns the location of the object's name. More...
 
- Properties inherited from NXOpen.NXObject
unsafe bool IsOccurrence [get]
 Returns whether this object is an occurrence or not. More...
 
unsafe string JournalIdentifier [get]
 Returns the identifier that would be recorded in a journal for this object. More...
 
unsafe string Name [get]
 Returns the custom name of the object. More...
 
unsafe NXOpen.Assemblies.Component OwningComponent [get]
 Returns the owning component, if this object is an occurrence. More...
 
unsafe NXOpen.BasePart OwningPart [get]
 Returns the owning part of this object More...
 
unsafe NXOpen.INXObject Prototype [get]
 Returns the prototype of this object if it is an occurrence. More...
 
- Properties inherited from NXOpen.INXObject
bool IsOccurrence [get]
 Returns whether this object is an occurrence or not. More...
 
string JournalIdentifier [get]
 Returns the identifier that would be recorded in a journal for this object. More...
 
string Name [get]
 Returns the custom name of the object. More...
 
NXOpen.Assemblies.Component OwningComponent [get]
 Returns the owning component, if this object is an occurrence. More...
 
NXOpen.BasePart OwningPart [get]
 Returns the owning part of this object More...
 
NXOpen.INXObject Prototype [get]
 Returns the prototype of this object if it is an occurrence. More...
 

Detailed Description

Represents a section

Section consists of "chained_entity", a chain or a single entity of edge or curve. The entire chain(or a single entity) may be used by the section or only a portion of the chain (or single entity) might be used. The portion of the chain (or single entity) that is used is defined by the "start_connector" and "end_connector".

start_connector: It represents the start of the portion of the chain (or single entity) that is used. If "start_connector" is null (Nothing), then the start point of the chained_entity along its "natural" direction is used.

start_connector_intersection_point: The point of intersection of the "chained_entity" and the "start_connector". This is used to determine what portion of the chain to use in case the "start_connector" intersects the "chained_entity" in multiple locations.

end_connector: It represents the end of the portion of the chain (or single entity) that is used.

end_connector_intersection_point: The point of intersection of the "chained_entity" and the "end_connector". This is used to determine what portion of the chain to use in case the "end_connector" intersects the "chained_entity" in multiple locations.

To create a new instance of this class, use NXOpen.SectionCollection.CreateSection

Created in NX3.0.0

Member Enumeration Documentation

Defines entity types allowed.

Enumerator
Uninitialized 

This is uninitialized state.

Do not use this.

OnlyCurves 

Allow only curves in section

OnlyPoints 

Allow only points in section

CurvesAndPoints 

Allow both points and curves in section

Defines type of deselect option.

Enumerator
SectionBetweenIntersection 

Potion of the loop between intersections will be deselected this may contain multiple chains

CurveBetweenIntersection 

Portion of curve between intersection

Defines mode with respect to feature create or edit mode.

Enumerator
Create 

Feature is being created

Edit 

Feature is being edited

Member Function Documentation

unsafe void NXOpen.Section.AddChainBetweenIntersectionPoints ( NXOpen.SelectionIntentRule[]  rules,
NXOpen.NXObject  startConnector,
NXOpen.Point3d  startIntersectionPoint,
NXOpen.NXObject  endConnector,
NXOpen.Point3d  endIntersectionPoint,
NXOpen.NXObject  seed,
NXOpen.Point3d  helpPoint,
NXOpen.Section.Mode  featureMode,
bool  chainWithinFeature 
)

Adds a chain between given two intersection points to the section.

Created in NX7.5.0

License requirements: gateway ("UG GATEWAY")

Parameters
rulesSelection intent rules. To create selection intent rules see documentation of ScRuleFactory for more details.
startConnectorIt represents the start of the portion of the chain (or single entity) that is used. If "startConnector" is a null reference (Nothing in Visual Basic), then the start point of the chained entity along its "natural" direction is used. It can be point, curve or edge
startIntersectionPointThe point where the start connector intersects with the chain.
endConnectorRepresents the end of the portion of the chain (or single entity) that is used. It can be point, curve or edge
endIntersectionPointThe point where the end connector intersects with the chain.
seedSeed curve, edge or face
helpPointThe point which is used to determine which portion of the chain to use for creating section.
featureModeFeature create or edit mode.
chainWithinFeatureTrue if chaining and discovery of intersection limits is to be restricted to the feature of the seed. This is effective only when the seed belongs to a curve feature.
unsafe void NXOpen.Section.AddSmartPoint ( NXOpen.Point  smartPt,
double  tol 
)

Add smart point into section.

This API is now deprecated. Please use ScRuleFactory.CreateRuleCurveDumb and Section.AddToSection instead.

Created in NX4.0.0

Deprecated in NX7.5.0. Please use ScRuleFactory.CreateRuleCurveDumb followed by Section.AddToSection instead.

License requirements: gateway ("UG GATEWAY")

Parameters
smartPtSmart point tobe added into section.
tolTolerance.
unsafe void NXOpen.Section.AddToSection ( NXOpen.SelectionIntentRule[]  rules,
NXOpen.NXObject  seed,
NXOpen.NXObject  startConnector,
NXOpen.NXObject  endConnector,
NXOpen.Point3d  helpPoint,
NXOpen.Section.Mode  featureMode 
)

Adds selection intent rules to the section.

Created in NX4.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
rulesSelection intent rules. To create selection intent rules see documentation of ScRuleFactory for more details.
seedSeed curve, edge or face
startConnectorIt represents the start of the portion of the chain (or single entity) that is used. If "start_connector" is null (Nothing), then the start point of the chained_entity along its "natural" direction is used. It can be point, curve or edge
endConnectorIt represents the end of the portion of the chain (or single entity) that is used. It can be point, curve or edge
helpPointWhen ambiguity in multiple solutions is encountered, help_point is used to determine which portion of the chain to use for creating section. It is most useful when used with non-NULL connectors or with Region Boundary Curves rule.
featureModeFeature create or edit mode.
unsafe void NXOpen.Section.AddToSection ( NXOpen.SelectionIntentRule[]  rules,
NXOpen.NXObject  seed,
NXOpen.NXObject  startConnector,
NXOpen.NXObject  endConnector,
NXOpen.Point3d  helpPoint,
NXOpen.Section.Mode  featureMode,
bool  chainWithinFeature 
)

Adds selection intent rules to the section with the option of restricting chaining and limit discovery to a single feature.

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
rulesSelection intent rules. To create selection intent rules see documentation of ScRuleFactory for more details.
seedSeed curve, edge or face
startConnectorIt represents the start of the portion of the chain (or single entity) that is used. If "start_connector" is null (Nothing), then the start point of the chained_entity along its "natural" direction is used. It can be point, curve or edge
endConnectorIt represents the end of the portion of the chain (or single entity) that is used. It can be point, curve or edge
helpPointWhen ambiguity in multiple solutions is encountered, help_point is used to determine which portion of the chain to use for creating section. It is most useful when used with non-NULL connectors or with Region Boundary Curves rule.
featureModeFeature create or edit mode.
chainWithinFeatureTrue if chaining and discovery of intersection limits is to be restricted to the feature of the seed. This is effective only when the seed belongs to a curve feature.
unsafe void NXOpen.Section.AlignDirectionOfLoop ( NXOpen.Point3d  point,
NXOpen.Vector3d  direction 
)

Set the direction of a single loop of the section along the given vector.

Created in NX5.0.1

License requirements: gateway ("UG GATEWAY")

Parameters
pointAny point on a the desired loop.
directionDesired tangent direction of the loop at the point.
unsafe void NXOpen.Section.AllowSelfIntersection ( bool  allowSelfIntersection)

Allow self intersecting section or not.

By default self intersection is allowed.

Created in NX4.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
allowSelfIntersectionTrue if self-intersecting section is allowed else false
unsafe void NXOpen.Section.CleanMappingData ( )

Cleans Mapping Data

This method should be used to clean mapping data after mapping is done

Created in NX7.5.0

License requirements: gateway ("UG GATEWAY")

unsafe void NXOpen.Section.Clear ( )

Clear the section of all its constituents

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

unsafe NXOpen.Section NXOpen.Section.CloneSection ( )

Clone section.

Created in NX7.0.0

License requirements: None.

Returns
the cloned section
unsafe void NXOpen.Section.DeselectPortion ( NXOpen.Point3d  seedPoint,
NXOpen.NXObject  startLimit,
NXOpen.NXObject  endLimit,
NXOpen.Section.DeselectOption  deselectionType 
)

Deselects Portion of the section depending on the option provided.

This method should be used to deselect portion of the section.

Created in NX7.5.0

License requirements: gateway ("UG GATEWAY")

Parameters
seedPointThe seed point of deselection
startLimitThe element that is connected to the curve/edge near its start point.
endLimitThe element that is connected to the curve/edge near its end point.
deselectionTypeThe deselection type
unsafe void NXOpen.Section.Destroy ( )

Destroy the section object

Created in NX4.0.0

License requirements: gateway ("UG GATEWAY")

unsafe void NXOpen.Section.EvaluateAndAskOutputEntities ( out NXOpen.NXObject[]  refs)

Recalculates section collection.

This is JA API for recalculating the section collection and to get the section collection after recalculation.

Created in NX9.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
refsThe array of section elements.
unsafe NXOpen.Section.AllowTypes NXOpen.Section.GetAllowedEntityTypes ( )

Get the Allowed Entity Types.

Works only for UF_SC_CURVE_dumb_data_s and UF_SC_CURVE_feature_data_s

Created in NX7.5.0

License requirements: gateway ("UG GATEWAY")

Returns
allowed entity types
unsafe int NXOpen.Section.GetLoopIndex ( NXOpen.NXObject  sectionElement)

Returns the index of the section loop conatining the section element.

If the section element does not exist in the section or is part of more than one loops, this method will return an error.

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
sectionElementan element that constructs the section
Returns
loop Index
unsafe int NXOpen.Section.GetLoopIndex ( NXOpen.Point3d  pointSpecifyingLoop,
double  tolerance 
)

Returns the index of the loop on which the given point lies.

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
pointSpecifyingLoopa point lying on the loop for which the loop index is being queried
toleranceTolerance for specifying point on loop.
Returns
loop Index
unsafe bool NXOpen.Section.GetMultiComponent ( )

Gets the option set on Section for collection from multiple components.

A multi-component Section can have collection from multiple components i.e., multiple parts or multiple instances of same part or both.

Created in NX9.0.0

License requirements: None.

Returns
Multi-component option set on Section
unsafe bool NXOpen.Section.GetNonFeatureMode ( )

Gets the option set on Section for collection in non-feature mode.

A Section in non-feature mode does not reference the feature data of the part from which the collection is done.

Created in NX9.0.0

License requirements: None.

Returns
Non-feature mode set on Section
unsafe void NXOpen.Section.GetOldOutputCurves ( out NXOpen.NXObject[]  oldOutputs)

Gives the old output curves of the section.

This method returns an array of old section curves. They were created internally and are different from the parent curves used to build the section. These curves should not be modified or deleted, doing so may result in part corruption and session may become unstable.

Created in NX7.5.0

License requirements: gateway ("UG GATEWAY")

Parameters
oldOutputsThe array of old section elements.
unsafe void NXOpen.Section.GetOutputCurves ( out NXOpen.NXObject[]  outputs)

Gives the output curves of the section.

This method returns an array of existing section curves. They are created internally and are different from the parent curves used to build the section. These curves should not be modified or deleted, doing so may result in part corruption and session may become unstable.

Created in NX7.5.0

License requirements: gateway ("UG GATEWAY")

Parameters
outputsThe array of section elements.
unsafe void NXOpen.Section.GetSectionData ( out NXOpen.SectionData[]  sectionData)

Gets the section data

Created in NX3.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
sectionDataSection data consists of selection intent rules, section elements, start and end connector.
unsafe void NXOpen.Section.GetSectionData ( bool  withOccurrenceInfo,
out NXOpen.SectionData[]  sectionData 
)

Gets the section data

Created in NX12.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
withOccurrenceInfoTrue to get occurrence instead of proto information
sectionDataSection data consists of selection intent rules, section elements, start and end connector.
unsafe void NXOpen.Section.GetStartAndDirection ( out NXOpen.ICurve  startElement,
out NXOpen.Point3d  startPoint,
out NXOpen.Vector3d  direction 
)

Gets the start element and the direction of the section.

Created in NX3.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
startElementThe element, curve or edge, specifying the starting of the section. If start element is point then this function will return error. If the section is a loop, then the loop is started by start_element and the direction is followed the input direction. If the section is not a loop, then the section can be started by other element, but the direction of the section is defined by the start_element and direction.
startPointThe origin of the vector that defines the direction of the section. This point has to be on the start_element.
directionThe direction of the vector defines the direction of the section.
unsafe void NXOpen.Section.GetStartAndDirectionOfLoop ( int  index,
out NXOpen.Point3d  startPoint,
out NXOpen.Vector3d  direction 
)

Gets the start point and the direction of a specified single loop of the section.

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
indexThe index of the loop of the section for which start point and direction are being queried.
startPointThe origin of the vector that defines the direction of the loop of the section specified by the index.
directionThe direction of the vector defines the direction of the loop of the section specified by the index.
unsafe void NXOpen.Section.MapSectionElements ( NXOpen.NXObject  oldWf,
NXOpen.NXObject  newWf 
)

Maps old section curves to new section curves

This method should be used to map old section curves to new section curves when some or all curves from section are removed and some or all new curves are added.

To find old section curves see documentation for Section.GetOldOutputCurves and to find current section curves see documentation for Section.GetOutputCurves

Created in NX7.5.0

License requirements: gateway ("UG GATEWAY")

Parameters
oldWfThe old section curve which was removed and hence needs to be mapped.
newWfThe new section curve that would be mapped to the old section curve.
unsafe void NXOpen.Section.PrepareMappingData ( )

Prepares Mapping Data

This method should be used to create mapping data if mapping is to be done

Created in NX7.5.0

License requirements: gateway ("UG GATEWAY")

unsafe void NXOpen.Section.RemoveMultipleCurves ( NXOpen.ICurve[]  wfs,
NXOpen.NXObject[]  startConnector,
NXOpen.NXObject[]  endConnector,
NXOpen.Section.Mode  featureMode 
)

Removes multiple section elements that are either curves/edges.

This API is now deprecated. Please use Section.RemoveMultipleElements instead.

Created in NX6.0.2

Deprecated in NX8.5.0. Please use Section.RemoveMultipleElements instead.

License requirements: None.

Parameters
wfsThe elements (curves/edges) that construct the section.
startConnectorThe element that is connected to the curve/edge near its start point.
endConnectorThe element that is connected to the curve/edge near its end point.
featureModeFeature create or edit mode.
unsafe void NXOpen.Section.RemoveMultipleElements ( NXOpen.ICurve[]  wfs,
NXOpen.NXObject[]  startConnectors,
NXOpen.NXObject[]  endConnectors,
bool[]  isCombinationsResultIntoOnlyOneCurvePerCombination,
NXOpen.Point3d[]  pointsOnCurvesToBeRemoved,
NXOpen.Point[]  points,
NXOpen.Section.Mode  featureMode 
)

Removes multiple section elements.

This method should be used to remove the multiple section elements from section when elements to be removed contains points, and some or all curves that can not be uniquely mapped with wireframe , start connector and end connector. For Such curves point laying on the curve should be specified

Created in NX6.0.2

License requirements: gateway ("UG GATEWAY")

Parameters
wfsThe elements (curves/edges) that construct the section.
startConnectorsThe element that is connected to the curve/edge near its start point.
endConnectorsThe element that is connected to the curve/edge near its end point.
isCombinationsResultIntoOnlyOneCurvePerCombinationWhether the combination of input curve/edge, Start Connector end Connector produces unique combination (i.e. they map to single section element) or not.
pointsOnCurvesToBeRemovedIf Combination can not define curve to be deselected uniquely, then point which lies on the curve to be removed should be provided, otherwise point must be given as (0, 0, 0) for corresponding combination
pointsThe points that are part of section and to be removed from the section.
featureModeFeature create or edit mode.
unsafe void NXOpen.Section.RemoveMultiplePoints ( NXOpen.Point[]  points,
NXOpen.Section.Mode  featureMode 
)

Removes multiple section elements that are points.

This API is now deprecated. Please use Section.RemoveMultipleElements instead.

Created in NX6.0.2

Deprecated in NX8.5.0. Please use Section.RemoveMultipleElements instead.

License requirements: gateway ("UG GATEWAY")

Parameters
pointsThe points that construct the section.
featureModeFeature create or edit mode.
unsafe void NXOpen.Section.RemoveRules ( NXOpen.SelectionIntentRule[]  rules,
NXOpen.NXObject  startConnector,
NXOpen.NXObject  endConnector,
NXOpen.Section.Mode  featureMode 
)

Removes selection intent rules from the section.

To get selection intent rules of the section see documentation for Section.GetSectionData and SectionData.GetRules for more details.

Created in NX3.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
rulesSelection intent rules.
startConnectorIt represents the start of the portion of the chain (or single entity) that is used. If "start_connector" is null (Nothing), then the start point of the chained_entity along its "natural" direction is used. It can be be point, curve or edge
endConnectorIt represents the end of the portion of the chain (or single entity) that is used. It can be be point, curve or edge
featureModeFeature create or edit mode
unsafe void NXOpen.Section.RemoveRules ( NXOpen.ICurve  sectionElement,
NXOpen.NXObject  startConnector,
NXOpen.NXObject  endConnector,
NXOpen.Section.Mode  featureMode 
)

Removes all the selection intent rules related to the section element.

To get selection elements of the section, see documentation for Section.GetSectionData and SectionData.GetSectionElementsData for more details.

Created in NX4.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
sectionElementThe element that constructs the section
startConnectorThe element that is connected to the section_element near its start_point
endConnectorThe element that is connected to the section_element near its end_point
featureModeFeature create or edit mode.
unsafe void NXOpen.Section.RemoveSingleSectionElement ( NXOpen.ICurve  sectionElement,
NXOpen.NXObject  startConnector,
NXOpen.NXObject  endConnector,
NXOpen.Section.Mode  featureMode 
)

Removes one section element curve.

To get selection element see documentation for Section.GetSectionData and SectionData.GetSectionElementsData for more details.

Created in NX4.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
sectionElementThe element that constructs the section
startConnectorThe element that is connected to the section_element near its start_point
endConnectorThe element that is connected to the section_element near its end_point
featureModeFeature create or edit mode
unsafe void NXOpen.Section.RemoveSingleSectionElement ( NXOpen.Point  sectionElement,
NXOpen.Section.Mode  featureMode 
)

Removes one section element that is a point.

To get selection element see documentation for Section.GetSectionData and SectionData.GetSectionElementsData for more details.

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
sectionElementThe point that constructs the section
featureModeFeature create or edit mode
unsafe void NXOpen.Section.RemoveUnderlyingChain ( NXOpen.Point3d  pointSpecifyingChain,
double  tolerance,
NXOpen.Section.Mode  featureMode 
)

Removes all the selection intent rules related to the chain on which the given point lies.

This method should be used in place of Section.RemoveRules when the part containing the section element is not loaded.

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
pointSpecifyingChainThe point should lie on the chain that is to be removed.
toleranceTolerance for specifying point on chain.
featureModeFeature create or edit mode.
unsafe void NXOpen.Section.RemoveUnderlyingCurve ( NXOpen.Point3d  pointSpecifyingCurve,
double  tolerance,
NXOpen.Section.Mode  featureMode 
)

Removes the single curve which is within tolerance to the given point, from the section.

This method should be used in place of Section.RemoveSingleSectionElement in any of the conditions: when the part containing the section element is not loaded, when the combination of input curve, start connector and end connector maps to multiple section element, or when underlying parent is invalid.

Created in NX6.0.2

License requirements: gateway ("UG GATEWAY")

Parameters
pointSpecifyingCurveThe point should lie on the curve that is to be removed.
toleranceTolerance for specifying point on curve.
featureModeFeature create or edit mode.
unsafe void NXOpen.Section.ReverseDirection ( )

Reverse the section direction

Created in NX4.0.0

License requirements: gateway ("UG GATEWAY")

unsafe void NXOpen.Section.ReverseDirectionOfClosedLoop ( int  index)

Reverse the loop direction of a closed loop while keeping the start curve same.

This API can only be used closed loops.

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
indexIndex of the closed loop for which the direction is to be reversed.
unsafe void NXOpen.Section.ReverseDirectionOfLoop ( int  index)

Reverse the direction of of a specified single loop of the section.

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
indexThe index of the loop of the section that is to be reversed.
unsafe void NXOpen.Section.SetAllowedEntityTypes ( NXOpen.Section.AllowTypes  allowedEntityTypes)

Set the Allowed Entity Types.

Works only for UF_SC_CURVE_dumb_data_s and UF_SC_CURVE_feature_data_s

Created in NX7.5.0

License requirements: gateway ("UG GATEWAY")

Parameters
allowedEntityTypesAllowed entity types.
unsafe void NXOpen.Section.SetAllowRefCrvs ( bool  allowRefCrvs)

Sets to the section whether to allow reference curves or not.

This is JA API for setting to the section whether to allow reference curves or not.

Created in NX10.0.0

License requirements: None.

Parameters
allowRefCrvs
unsafe void NXOpen.Section.SetInterpart ( bool  interpart)

Set inter-part state of section and make it empty.

This function sets the value of interpart flag on Section. Error will be raised while setting this option on Section in following conditions: (1) Multi-component option is already set on Section.

Created in NX6.0.0

License requirements: None.

Parameters
interpartTrue to set section interpart
unsafe void NXOpen.Section.SetMultiComponent ( )

Sets the true option on Section for collection from multiple components.

A multi-component Section can have collection from multiple components i.e., multiple parts or multiple instances of same part or both. This method should be used only if such collection is desired. Error will be raised while setting this option on Section in following conditions: (1) Inter-part option is already set on Section.

Created in NX9.0.0

License requirements: None.

unsafe void NXOpen.Section.SetNonFeatureMode ( )

Sets the true option on Section for collection in non-feature mode.

A Section in non-feature mode does not reference the feature data of the part from which the collection is done. The option should be set on an empty Section only. For a non-empty Section, setting this option will raise error in following conditions: (1) Section is referencing feature data and non-feature mode is set true. (2) Section is not referencing feature data and non-feature mode is set false.

Created in NX9.0.0

License requirements: None.

unsafe void NXOpen.Section.SetStartAndDirection ( NXOpen.ICurve  startElement,
NXOpen.Point3d  startPoint,
NXOpen.Vector3d  direction 
)

Sets the start element and the direction of the section.

Created in NX3.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
startElementThe element, curve or edge, specifying the starting of the section. If the section is a loop, then the loop is started by start_element and the direction is followed the input direction. If the section is not a loop, then the section can be started by other element, but the direction of the section is defined by the start_element and direction.
startPointThe origin of the vector that defines the direction of the section. This point has to be on the start_element.
directionThe direction of the vector defines the direction of the section.
unsafe void NXOpen.Section.SetStartCurveOfClosedLoop ( int  index,
NXOpen.Point3d  pointOnStartCurve 
)

Set the curve on which the specified point lies as the start curve of a specified single loop of the section.

Created in NX5.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
indexIndex of the loop for which the start curve is to be set.
pointOnStartCurveAny point on a curve that is to be set as the start curve.
unsafe void NXOpen.Section.SkipSorting ( bool  skipSorting)

Sets the option to skip sorting the section loops or not.

This method should be used rare scenarios. In normal situation this method should never be used. If sort option is set to true then it should be set to false after required operation is done. If sort option is set to true then section loops are not sorted and output will not be in order.

Created in NX8.0.0

License requirements: gateway ("UG GATEWAY")

Parameters
skipSortingTrue to skip sorting of section loops else false

Property Documentation

unsafe double NXOpen.Section.AngleTolerance
getset

Returns or sets the angle tolerance

Created in NX3.0.0

License requirements to get this property: gateway ("UG GATEWAY")

License requirements to set this property: gateway ("UG GATEWAY")

unsafe double NXOpen.Section.ChainingTolerance
getset

Returns or sets the chaining tolerance

Created in NX3.0.0

License requirements to get this property: gateway ("UG GATEWAY")

License requirements to set this property: gateway ("UG GATEWAY")

unsafe double NXOpen.Section.DistanceTolerance
getset

Returns or sets the distance tolerance

Created in NX3.0.0

License requirements to get this property: gateway ("UG GATEWAY")

License requirements to set this property: gateway ("UG GATEWAY")


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.